/*
 *
 * ShortcutCommands
 * 
 * A class that simplifies some of the current vanilla commands with shortcut commands in the game 
*/

package jesse.keeblarcraft.Commands;

import com.mojang.brigadier.arguments.IntegerArgumentType;
import com.mojang.brigadier.context.CommandContext;

import net.fabricmc.fabric.api.command.v2.CommandRegistrationCallback;
import net.minecraft.server.command.CommandManager;
import net.minecraft.server.command.ServerCommandSource;
import net.minecraft.server.network.ServerPlayerEntity;
import net.minecraft.text.Text;

public class ShortcutCommands {
    public void RegisterShortcutCommands()
    {
        // Abstract handling "value" to parse gamemodes 0-2 (survival; creative; spectator)
        CommandRegistrationCallback.EVENT.register((dispatcher, registryAccess, environment) -> {
            dispatcher.register(CommandManager.literal("gm")
            .then(CommandManager.argument("value", IntegerArgumentType.integer())
            .executes(context -> CreativeShortcut(IntegerArgumentType.getInteger(context, "value"), context))));
        });
    }


    /// Command handlers below

    private int CreativeShortcut(int value, CommandContext<ServerCommandSource> context)
    {
        int retValue = -1;
        context.getSource().sendMessage(Text.literal("You sent value: " + value));

        if (context.getSource().isExecutedByPlayer()) {
            ServerPlayerEntity player = context.getSource().getPlayer();

            /// todo: change 4 to be OPERATOR level. 4 is DEFAULT operator level in Minecraft
            if(player.hasPermissionLevel(4)) {
                switch(value) {
                    case 0:
                    /// TODO: Add type checking & permission
                        player.changeGameMode(net.minecraft.world.GameMode.SURVIVAL);
                        player.sendMessage(Text.literal("Changing your game mode to SURVIVAL"));
                        retValue = 0;
                        break;
                    case 1:
                        player.changeGameMode(net.minecraft.world.GameMode.CREATIVE);
                        player.sendMessage(Text.literal("Changing your game mode to CREATIVE"));
                        retValue = 0;
                        break;
                    case 2:
                        player.changeGameMode(net.minecraft.world.GameMode.SPECTATOR);
                        player.sendMessage(Text.literal("Changing your game mode to SPECTATOR"));
                        retValue = 0;
                        break;
                    default:
                        player.sendMessage(Text.literal("Valid entries are 0=SURVIVAL, 1=CREATIVE, 2=SPECTATOR"));
                        retValue = -1;
                    break;
                }

            }
            else {
                player.sendMessage(Text.literal("You do not have permissions to run this command!"));
            }
        }
        else {
            System.out.println("This command cannot be executed by a non-player entity!");
        }

        return retValue;
    }
    
}
